package Museum is

   ------------------------------------------
   --  the Museum abstraction is represented by
   --  the anonymous instance (i.e. one that has
   --  no defined type) "Guardian"
   --+
   --  visiting tourists must apply to the Guardian
   --  to obtain access permission
   --+
   --  access will be granted to groups of a fixed size only
   --  (denoted by the private value Group_Size)
   ------------------------------------------

   protected Guardian is
      entry Entrance;
      procedure Sortie;
   private
      function Is_Free return Boolean;
      Release : Boolean := False;
      Inside : Natural := 0; -- must not exceed Capacity
   end Guardian;

private

   Capacity      : constant Positive := 6; -- must be >= Group_Size
   Group_Size : constant Positive := 4; -- must be <= Capacity

end Museum;
